// @ myth - client - prompt.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef PROMPT_HEADER
#define PROMPT_HEADER

// @@ include

#include "common/common.h"
#include "client/window.h"
#include "common/command.h"
#include "common/string.h"

// @@ class

// @@@ PROMPT

class PROMPT : WINDOW
{
    prompt_type first;
    const char* error;
    bool FirstTouched;
    prompt_type second;
    long argument;
    STRING string;
    bool SecondTouched;
public:
    void select(prompt_type one, const char* message, 
		prompt_type two, long arg, const char* value = "");
    void update(force flag = CHECK);
    inline void flush()
    { update(FORCE); }
    PROMPT();
};

// @@ end

#endif PROMPT_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
