// @ myth - common - page.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef PAGE_HEADER
#define PAGE_HEADER

// @@ include

#include "common/common.h"
#include "common/string.h"
#include "common/list.h"

// @@ class PAGE

class PAGE : LIST
{
public:
    inline void add(STRING string)
    { LIST::add(new STRING(string)); }
    inline void add(char* string)
    { PAGE::add(STRING(string)); }
    inline void append(STRING string)
    { LIST::append(new STRING(string)); }
    inline void append(char* string)
    { PAGE::append(STRING(string)); }
    void remove();
    void clear();
    inline void reset(int target = 0)
    { LIST::reset(target); }
    inline void next()
    { LIST::next(); }
    inline STRING current()
    {
	if(LIST::current() == NULL)
	    return NullString;
	else
	    return *((STRING *) LIST::current());
    }
    inline const char* string()
    {
	if(LIST::current() == NULL)
	    return NULL;
	else
	    return PAGE::current().string();
    }
    inline int length()
    { return LIST::length(); }
    inline int remain()
    { return LIST::remain(); }
    inline int where()
    { return LIST::where(); }
    PAGE();
    ~PAGE();
};

// @@ end

#endif PAGE_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
