// @ myth - common - wait.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef WAIT_HEADER
#define WAIT_HEADER

// @@ include

#include "common/common.h"
#include "common/buffer.h"

// @@ struct buffer_link
//
// A link in the list of buffers used by WAIT.

struct buffer_link
{
    BUFFER* buffer;
    buffer_link* next;
    buffer_link(BUFFER* buf, buffer_link* link = NULL)
    { buffer = buf; next = link; }
};

// @@ * class WAIT

class WAIT
{
    buffer_link* list;		// Active buffers
    int table;			// Number of file descriptors
    int length;			// Number of int's used in BitArray
    int* files;			// BitArray of active fd's
    int* mask;			// Copy of files to select
    void set(int fd);		// Set bit in files
    void clear(int fd);		// Clear bit in files
    bool test(int* mask, int fd); // Test bit in mask
public:
    void add(BUFFER* buf);
    void remove(BUFFER* buf);
    void check(int timeout = ERROR);
    WAIT();
};

// @@ end

#endif WAIT_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
